﻿// https://gitlab.com/api/v4/projects/12595559/repository/archive.zip
// bremsleuchten erst wenn motor an ist
var TM, I18N, Utilities;
var options = {
    mph: false,
    mphPredefined: false,
    lang: navigator.language || navigator.userLanguage,
    game: '',
    data: {
        odometerFromStart: 0,
        fuelFromStart: 0,
        fuel: 0,
    }
};

var projectId = '12595559'
var initAnimation = false;
var showAll = false;
var showDevelopmentVariables = false;
var initialized  = true;
var animate = true;

var update = {
    available: false,
    checked : false
}

Funbit.Ets.Telemetry.Dashboard.prototype.initialize = function (skinConfig, utils) {
    $.getScript( `skins/${skinConfig.name}/js/TelemetryManager.js`, function() {
        I18N = new Translator();
        Utilities = new Utilities();
        Utilities.checkUpdate(projectId);
        Utilities.drawBackgroundPoints(700, 141.9, 20, 30, 3)
        var conversion = new Conversion();
        // Utilities.mapKeys(skinConfig);

        Funbit.Ets.Telemetry.Dashboard.prototype.filter = function (data, utils) {
            TM = new TelemetryManager(data, utils);

            TM.predefineData();
            return data;
        }

        Funbit.Ets.Telemetry.Dashboard.prototype.render = function (data, utils) {
            var DH = new DisplayHelper(data, utils, conversion);

            // simulates turning on and off the dashboard 
            Utilities.init(data, {'initialize': 'rgb(1, 4, 6)', 'engine-off': 'black'});

            
            Utilities.setVelocityUnit(data);

            // set speed limit
            Utilities.setSpeedLimit(data.navigation.speedLimit, 141.9, 301.9, 125, 650);

            // Indicates when the speed limit has been exceeded 
            Utilities.showSpeeding(data);
        
            // set perfect rpm color (1000 - 1400 rpm)
            DH.showPerfectRpm('perfect-rpm', 'green', 10, 14);
            
            // set fuel and adblue capacity text
            DH.fuelText(['fuel', 'adblue']);
        
            // show or hide elements when truck electric is on or off
            if (data.truck.electricOn) {
                $('.adblue-current-text, .fuel-current-text').css('opacity', 1);
                $('.fuel-wrapper, .adblue-wrapper, .truck-gear-wrapper').css('opacity', 1);
                $('.consumption-text').css('opacity', 1);
                // $('.triangle-line').css('opacity', 1);
                $('.airpressure-wrapper, .fuel-avg-wrapper').css('opacity', 1);
                $('.current-velocity, .game-velocityUnit').css('opacity', 1);
                $('.consumption-text > .text-1').html(utils.formatFloat(data.truck.fuelAverageConsumption, 1));
                $('.velocity-limit').css('opacity', data.navigation.speedLimit ? 1 : 0);
            } else {
                $('.adblue-current-text, .fuel-current-text').css('opacity', 0);
                $('.fuel-wrapper, .adblue-wrapper, .truck-gear-wrapper').css('opacity', 0);
                $('.consumption-text').css('opacity', 0);
                // $('.triangle-line').css('opacity', 0);
                $('.airpressure-wrapper, .fuel-avg-wrapper').css('opacity', 0);
                $('.velocity-limit, .current-velocity, .game-velocityUnit').css('opacity', 0);
            }

            // set driving mode
            $('.drivingMode').html(data.truck.drivingMode)

            // set fuel and adblue bar
            $('._fuelBar_').width(`${data.truck.fuelPercentage}%`);
            $('._adblueBar_').width(`${data.truck.adbluePercentage}%`);

            // set fuel average consumption bar
            $('.triangle-line').css('width', `${data.truck.fuelAverageConsumptionPercentage + 2}px`);
        
            // set velocity limit
            $('.velocity-limit > .circle-red').html(data.navigation.speedLimit)
        
            // set current velocity
            $('.current-velocity').html(data.truck.speedRounded);

            // set current gear
            $('.truck-gear-wrapper > .gear').html(data.truck.gear);
            
            // shows the maximum available gears for the current direction of travel
            $('.truck-gear-wrapper > .gear-max').html(data.truck.maxGears);
            
            // set displayed gear ([R | N | A] => automatic | [R | N | G] => manual)
            $('.truck-gear-wrapper > .gear-name').html(data.truck.displayedGear);
        
            // set predictive powertrain control (ppc or cruisecontrol)
            $('.ppc-wrapper > .truck-icon').css('color', data.truck.cruiseControlOn 
                ? 'rgb(0, 255, 255)' 
                : 'rgb(160, 160, 160)'
            );
            $('.ppc-wrapper').css('opacity', data.truck.cruiseControlOn 
                ? 1 
                : data.truck.electricOn
                    ? .2
                    : 0
            );
            $('.ppc-velocity').html(data.truck.cruiseControlSpeedRounded);
            
            // set blinker left
            Utilities.toggleLights(data.truck.blinkerLeftOn, [
                'truck-blinker-left'
            ])

            // set blinker right
            Utilities.toggleLights(data.truck.blinkerRightOn, [
                'truck-blinker-right'
            ])

            // set brake lights
            Utilities.toggleLights(data.truck.gameBrake, [
                'truck-brake-left', 
                'truck-brake-right'
            ])

            // set reverse lights
            Utilities.toggleLights(data.truck.displayedGear === 'R', [
                'truck-reverse-left',
                'truck-reverse-right'
            ])

            // set parking lights
            Utilities.toggleLights(data.truck.lightsParkingOn, [
                'truck-light-left-1',
                'truck-light-left-2',
                'truck-light-right-1',
                'truck-light-right-2'
            ])

            // set front light visibility
            if (data.truck.lightsParkingOn) {
                $('.street-right-stripe, .street-left-stripe').addClass('cut');
                if (data.truck.lightsBeamHighOn) {
                    $('.street-right-stripe-high-beam, .street-left-stripe-high-beam, .truck-high-beam-wrapper').show();
                } else {
                    $('.street-right-stripe-high-beam, .street-left-stripe-high-beam, .truck-high-beam-wrapper').hide();
                    $('.street-right-stripe-low-beam, .street-left-stripe-low-beam, .truck-low-beam-wrapper').show();
                }
            } else {
                $('.street-right-stripe, .street-left-stripe').removeClass('cut');
                $('.street-right-stripe-low-beam, .street-left-stripe-low-beam, .truck-low-beam-wrapper').hide();
                $('.street-right-stripe-high-beam, .street-left-stripe-high-beam, .truck-high-beam-wrapper').hide();
            }
        
            // toggle truck and trailer
            if (data.trailer.attached) {
                $('.trailer-image').show();
                $('.truck-image').hide();
            } else {
                $('.trailer-image').hide();
                $('.truck-image').show();
            }

            // set air pressure
            $('.airpressure-wrapper > ._airBar_').css('width', `${data.truck.airPressurePercentage}%`);
            $('.airpressure-wrapper > .air-current-text > .text-1').html(data.truck.airPressureBarText);

            // set fatique
            DH.fatique('fatigue', 'rgb(40, 40, 40)', 'rgb(255, 166, 0)', '#ff0000');
            
            
            $('.right-display').html();
        };
    });
}

